import unittest
from redirector.tests.utils import get_abs_path, get_rel_path

from redirector.redirector import *
from redirector.utils import generators
from redirector.utils import parser
from redirector.utils.const import MAPS_DIR, CONFIG_DIR, CONFIG


class EqualRedirectorTest(unittest.TestCase):
    def setUp(self):
        self.redirector = Redirector()

    def test_equal_map(self):
        abs_yaml_path = get_abs_path(CONFIG)
        abs_test_path = get_abs_path('test.map')

        abs_res_conf_path = get_rel_path(f"{CONFIG_DIR}/test.conf")

        res_conf_file = open(abs_res_conf_path, 'r')
        res_conf_lines = []

        for line in res_conf_file:
            if len(line) > 2 or not line.startswith('#'):
                res_conf_lines.append(line)

        res_conf_file.close()

        maps_dir = get_rel_path(MAPS_DIR)
        abs_res_map_paths = [
            f"{maps_dir}/test.map",
            f"{maps_dir}/test_permanent_options.map",
            f"{maps_dir}/test_status=301_options.map"
        ]

        res_map_lines = []

        for path in abs_res_map_paths:
            f = open(path, 'r')

            for line in f:
                if len(line) > 2 or not line.startswith('#'):
                    res_map_lines.append(line)

            f.close()
        
        self.redirector.generate(abs_yaml_path, abs_test_path)

        abs_test_conf_path = get_rel_path('nginx/location-includes/test.conf')
        test_conf_file = open(abs_test_conf_path, 'r')
        test_conf_lines = []

        for line in test_conf_file:
            if len(line) > 2 or not line.startswith('#'):
                test_conf_lines.append(line)

        test_conf_file.close()

        test_maps_dir = get_rel_path('nginx/maps')
        abs_test_map_paths = [
            f"{test_maps_dir}/test.map",
            f"{test_maps_dir}/test_permanent_options.map",
            f"{test_maps_dir}/test_status=301_options.map"
        ]

        test_map_lines = []

        for path in abs_test_map_paths:
            f = open(path, 'r')

            for line in f:
                if len(line) > 2 or not line.startswith('#'):
                    test_map_lines.append(line)

            f.close()

        self.assertEqual(res_conf_lines, test_conf_lines)
        self.assertEqual(res_map_lines, test_map_lines)

