import os

from setuptools import setup
from redirector.utils import const

classifiers_list = [
    "Development Status :: 4 - Beta",
    "Environment :: Plugins",
    "Operating System :: Ubuntu",
    "Programming Language :: Python%s" % const.PYTHON_VERSION,
    "Topic :: System",
    "Topic :: Utilities",
    {
        "alpha": "Development Status :: 3 - Alpha",
        "beta": "Development Status :: 4 - Beta",
        "stable": "Development Status :: 5 - Production/Stable"
    }[const.VERSION_STATUS]
]


setup(
    name=const.NAME, 
    version="0.1.1",
    description="CLI-utility for building nginx redirects",
    long_description=open('README.md').read(),
    author="Nikita Efremov, Dobryakov David",
    author_email="kantegory@etersoft.ru",
    url="https://gitlab.eterfund.ru/eterfund/nginx-redirector/",
    license="ISC",
    packages=['redirector', 'redirector.utils', 'redirector.tests'],
    entry_points={
        'console_scripts': [
            'nginx-redirector = redirector.redirector:main',
            'nginx-redirector-watch = redirector.watcher:watch',
            'nginx-redirector-convert = redirector.htaccess_parser:main'
        ]
    },
    classifiers=classifiers_list,
    install_requires=[
        'pyinotify',
        'pyyaml'
    ],
    include_package_data=True,
    test_suite="redirector.tests"
)

